Bug 18100 - i965 supports textures up to 8192x8192, but mesa is limited to 2048x2048
Summary: i965 supports textures up to 8192x8192, but mesa is limited to 2048x2048
Status: RESOLVED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i965 (show other bugs)
Version: unspecified
Hardware: Other All
: medium enhancement
Assignee: Keith Packard
QA Contact:
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-10-16 21:14 UTC by Marius Gedminas
Modified: 2009-03-10 22:48 UTC (History)
9 users (show)

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Marius Gedminas 2008-10-16 21:14:34 UTC
This is most noticeable when you're trying to use Compiz and a dual-head screen, where the desktop size exceeds 2048 pixels in at least one direction.  The desktop window exceeds the Mesa texture limit and fails to draw.

Keith Packard floated a patch to increase the Mesa texture size limit to 4096x4096 on the xorg mailing list in April: http://lists.freedesktop.org/archives/xorg/2008-April/034707.html

With that patch applied I can use Compiz with dual-head.

The bug is also reported in Ubuntu as https://bugs.launchpad.net/ubuntu/+source/mesa/+bug/146859
Comment 1 Klaasjan Brand 2008-12-01 07:13:36 UTC
Tested this patch on Fedora 10 and seems to be working.
Comment 2 Stefan Dirsch 2008-12-29 18:32:58 UTC
I'm seing all kind of issues when using compiz with the patch applied. It doesn't seem to be complete.
Comment 3 qwang13 2008-12-29 22:37:25 UTC
I don't read this patch in Mesa master and Q3 release. Is it missed? or there is another resolution for this.

any comment?
Comment 4 Klaasjan Brand 2008-12-31 05:01:25 UTC
Stefan: what kind of issues? (I'd like to know what to look out for).
And do they occur directly after launching compiz or after a while?
Comment 5 Gordon Jin 2009-01-31 20:54:53 UTC
The patch has been committed into mesa master, so I guess this bug can be closed?

Author: Keith Packard <keithp@keithp.com>
Date:   Fri Jan 30 21:51:32 2009 -0800

i965: bump texture limit to 4kx4k

Rendering and textures are limited to 8kx8k, but mesa limits things to
4kx4k, and magic guard band stuff may break on 8kx8k drawing. This is safe
though, and makes compiz work on bigger screens.

Comment 6 qwang13 2009-01-31 21:29:31 UTC
(In reply to comment #5)
> The patch has been committed into mesa master, so I guess this bug can be
> closed?
> 
> Author: Keith Packard <keithp@keithp.com>
> Date:   Fri Jan 30 21:51:32 2009 -0800
> 
> i965: bump texture limit to 4kx4k
> 
> Rendering and textures are limited to 8kx8k, but mesa limits things to
> 4kx4k, and magic guard band stuff may break on 8kx8k drawing. This is safe
> though, and makes compiz work on bigger screens.
> 

Gordon, the commit seems the same as http://lists.freedesktop.org/archives/xorg/2008-April/034707.html. However based on based on comment#2, Seems Stefan still has some problem with this patch.

Stefan, would you like to list the issues when you use compiz with this patch? It will be helpful for upstream to track what the side effect is?

Thanks
Comment 7 Stefan Dirsch 2009-02-01 00:18:19 UTC
Yes, it's exactly the same patch I have used in the past, but disabled after all.
The issues were, that with compiz enabled changing resolution via RANDR 1.2 (xrandr, ...) weren't possible any longer at all or resulted in strange effects.
See https://bugzilla.novell.com/show_bug.cgi?id=441572 for more details. Unfortunately it contains a lot of confusing comments. :-(
Comment 8 Marius Gedminas 2009-02-02 09:29:52 UTC
Trying to follow that link to Novell's bug tracker redirects me to a login page.

I have the following issues with Compiz and xrandr:

  * Sometimes after you change the desktop size Compiz doesn't notice and renders only to a part of the area, keeping the rest filled with garbage.  Sometimes it stops rendering at all, so you see the old picture (plus some garbage in new areas) and a moving mouse cursor.  Alt+F2, compiz --replace, Enter fixes this.

  * Sometimes after I shrink the desktop size mesa crashes the X server with "Assertion `intel->batch->cliprect_mode != REFERENCES_CLIPRECTS' failed".

I never thought to attribute those problems to this patch.  I suppose I could revert to pristine mesa and do some testing, if I can find the time.
Comment 9 Gordon Jin 2009-02-23 23:56:03 UTC
I think this bug should be closed as the fix against the original problem has been committed. The new issue (found by Stefan) should be filed as another bug.
Comment 10 Eric Anholt 2009-03-06 16:58:45 UTC
This is fixed by:

commit 954dfba12986f578f2d8461818f9e9ac1f8f2b41
Author: Keith Packard <keithp@keithp.com>
Date:   Fri Jan 30 21:51:32 2009 -0800

    i965: bump texture limit to 4kx4k
    
and

commit 88b702e8c47c8930940c396132b2a191d4a3e7ca
Author: Robert Ellison <papillo@i965-laptop.(none)>
Date:   Fri Feb 13 15:19:04 2009 -0700

    i965: Eric Anholt's patch for bumping up texture sizes

One of the unrelated reports in here should be fixed by:

commit 73aa23d9150121a4e4b70a78cab910acd164abf5
Author: Eric Anholt <eric@anholt.net>
Date:   Fri Dec 5 13:06:05 2008 -0800

    DRI1: Update sarea (and other information) when CRTC configuration changes.

All other issues: go get your own bugreport.
Comment 11 Stefan Dirsch 2009-03-10 22:48:02 UTC
(In reply to comment #10)
> commit 73aa23d9150121a4e4b70a78cab910acd164abf5
> Author: Eric Anholt <eric@anholt.net>
> Date:   Fri Dec 5 13:06:05 2008 -0800
> 
> DRI1: Update sarea (and other information) when CRTC configuration changes.

... which requires this fix:

commit dc12c4b3eb297b2f225409eacf1f3cd521453ab6
Author: Eric Anholt <eric@anholt.net>
Date:   Sat Mar 7 23:22:54 2009 -0800

    Flip the update_dri_buffers test around to only run when DRI1 is active.
    
    Fixes segfaults at startup with DRI2 and load detection, or with DRI
    disabled entirely.

BTW, both commits are from xf86-video-intel, the previous two from Mesa git.




Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct.